#include "cSocket.h"
#include "misc.h"
#include "sTag.h"
#include "sPacket.h"
#include "sGui.h"
#include "sFile.h"
#include "donkey.h"
#include "protocol.h"
#include "cygwin.h"
#include "sServer.h"
#include "cServer_udp.h"
#include "opcodes.h"

int  cServer_udp::REQ_file_ping  (in_addr ip, uint16_t port, char *file_hash) {{{ // (0x90)
	char BUF[18], *buf = BUF;;
	size_t len, LEN = len = 18;
	ADD_U1   (&buf, &len, OP_EMULEPROT);
	ADD_U1   (&buf, &len, OP_REASKFILEPING);
	ADD_HASH (&buf, &len, (uint8_t*)file_hash);
	peer_ip.s_addr = ip.s_addr;
	peer_port =port;
	return Write(BUF, LEN);
	// OP_QUEUEFULL,0,OP_EMULEPROT)	<-- forerst nicht nutzen
	}}}
bool cServer_udp::UDP_next_ping         (                                   ) {{{ // (0x96)
	uint32_t quest;
	if (!nextPing (&peer_ip, &peer_port, &quest)) return false;
//	printf("%s > 0x0096 [%15s] Server_ping\n", currentTime_str, inet_ntoa(peer_ip));
	peer_port += 4;
	char MSG[6];
	char *msg = MSG;
	unsigned msg_len = 6;
	ADD_U1 (&msg, &msg_len, OP_EDONKEYHEADER);
	ADD_U1 (&msg, &msg_len, OP_GLOBSERVSTATREQ);
	ADD_U4 (&msg, &msg_len, quest);
	msg = MSG;
	return Write(msg, 6);
	}}}
bool cServer_udp::UDP_search4gui        (const sGui *gui                    ) {{{ // (0x98)
	struct in_addr ip;
	if (!nextServer (&ip, &peer_port)) return false;
        peer_ip    = ip;
        peer_port += 4;
	ASSERT(peer_port != 0);
	printf("Extending search to %s %u\n", inet_ntoa(ip), peer_port);
	ASSERT (gui!=NULL);
	unsigned char *buf = (unsigned char*)MALLOC (gui->searchLen() + 2);
	buf [0] = OP_EDONKEYHEADER;
	buf [1] = OP_GLOBSEARCHREQ;
	memcpy ( buf+2, gui->searchTree(), (size_t) gui->searchLen());
	bool ok = Write((char*)buf, gui->searchLen() + 2);
	Free2 (buf);
	return ok;
	}}}
bool cServer_udp::UDP_req_sources       (in_addr ip,uint16_t port, const uint8_t *Hash) {{{ // (0x9A)
	if (0 == (ip.s_addr & 0xFF000000)) return false;
	if (0 == (ip.s_addr & 0x000000FF)) return false;
	class sFile *file = forHash(Hash);
	if (file == NULL) return false;
	ASSERT(file->status != ALL_DONE && !file->Pause());
	peer_port = port + 4;
        peer_ip   = ip;
	if (port == 0) return false;
	if (!IP_is_OK (ip)) return false;
//	if (protocol_logLevel == 9) 
//		printf("%s > 0x009A srv_udp  [%15s] Server_source %32s\n", currentTime_str, inet_ntoa(peer_ip), hash_bin2hex(Hash));
	char MSG[18];
	char *msg = MSG;
	unsigned msg_len = 18;
	ADD_U1   (&msg, &msg_len, OP_EDONKEYHEADER);
	ADD_U1   (&msg, &msg_len, OP_GLOBGETSOURCES);
	ADD_HASH (&msg, &msg_len, (const uint8_t*)Hash);
	actionServer    (ip, port);
	msg = MSG;
	return Write(msg, 18);
	}}}
bool cServer_udp::UDP_req_callback      (uint32_t idx) {{{ // (0x9C)
	unsigned len, LEN = len = 12;
	char BUF[12], *buf = BUF;
	ADD_U1 (&buf, &len, OP_EDONKEYHEADER	);
	ADD_U1 (&buf, &len, OP_GLOBCALLBACKREQ	);
	ADD_U4 (&buf, &len, my_ip.s_addr	);
	ADD_U2 (&buf, &len, pref.ports.client	);
	ADD_U4 (&buf, &len, idx			);
	ASSERT (len == 0);
	return Write(BUF, LEN);
	}}}
bool cServer_udp::UDP_next_info         (in_addr ip, uint16_t port          ) {{{ // (0xA2)
//	printf("%s > 0x00A2 [%15s] Server_desc\n", currentTime_str, inet_ntoa(peer_ip));
	peer_ip    = ip;
	peer_port  = port + 4;
	// Only called if ul/dl left > 0
	unsigned char MSG[2] = { OP_EDONKEYHEADER, OP_SERVER_DESC_REQ};
	return Write((char*)MSG, 2);
	}}}
bool cServer_udp::UDP_server_lst        (in_addr ip, uint16_t port          ) {{{ // (0xA4)
	peer_ip    = ip;
	peer_port  = port + 4;
	// Only called if ul/dl left > 0
	unsigned char MSG[2] = { OP_EDONKEYHEADER, OP_SERVER_LIST_REQ};
	return Write((char*)MSG, 2);
	}}}
bool cServer_udp::UDP_req_server_list   (struct in_addr ip, uint16_t port   ) {{{ // (0xA4)
	peer_port = port + 4;
	peer_ip   = ip;
	unsigned char MSG[2];
	char *msg = (char*)MSG;
	msg[0] = (uint8_t)OP_EDONKEYHEADER;
	msg[1] = (uint8_t)OP_SERVER_LIST_REQ;
	return Write(msg, 2);
	}}}

// Client-Server UDP handling (0x97) ... (0x9B)
int cServer_udp::RES_rang       (unsigned char *data, size_t len) {{{ // (0x91)
	struct eSources *info = Source_ip(peer_ip);
	if (info == NULL) return 0;
	setSources_version (peer_ip, info->version | 0x01000000);
	unsigned rank = GET_U2((char**)&data, &len);
	if (rank > 500) setSources_timeout(peer_ip, currentTime + 20 * 60); else
	if (rank > 300) setSources_timeout(peer_ip, currentTime + 15 * 60); else
	if (rank > 100) setSources_timeout(peer_ip, currentTime + 10 * 60); else
	if (rank >  10) setSources_timeout(peer_ip, currentTime +  5 * 60); else
	if (rank ==  0) {
		setSources_timeout(peer_ip, currentTime - 10);
		setSources_version (peer_ip, info->version & 0xFEFFFFFF);
		}
//	printf("< %s udp [%15s]() SLOT %i\n", currentTime_str, inet_ntoa(peer_ip), rank);
	return 1;
	}}}
int cServer_udp::RES_not_found  (unsigned char *    , size_t    ) {{{ // (0x92)
//	printf("< %s udp [%15s]() not_found\n", currentTime_str, inet_ntoa(peer_ip));
	struct eSources *info = Source_ip(peer_ip);
	if (info == NULL) return 0;
	setSources_version (peer_ip, info->version | 0x01000000);
	setSources_timeout(peer_ip, currentTime - 10);
	if (info == NULL) return 0;
	FILE_LIST {
		if (File_info_get(info->hash,akt->hash,akt->size, NULL)) {
			File_info_del   (info->hash,akt->hash);
			return 1;
			}
		}
	return 1;
	}}}
int cServer_udp::RES_queue_full (unsigned char *    , size_t    ) {{{ // (0x93)
//	printf("< %s udp [%15s]() queue_full\n", currentTime_str, inet_ntoa(peer_ip));
	struct eSources *info = Source_ip(peer_ip);
	if (info == NULL) return 0;
	setSources_version (peer_ip, info->version | 0x01000000);
	setSources_timeout(peer_ip, currentTime + 5 * 60);
	return 1;
	}}}
int cServer_udp::REQ_ping       (unsigned char *data, size_t len) {{{ // (0x96)
	int cnt = sServer::count;
	uint32_t query = GET_U4((char**)&data, &len);
	char BUF[14], *buf = BUF;;
	size_t LEN = len = 14;
	ADD_U1(&buf, &len, OP_EDONKEYHEADER);
	ADD_U1(&buf, &len, OP_GLOBSERVSTATRES);
	ADD_U4(&buf, &len, query);
	ADD_U4(&buf, &len, cnt);
	ADD_U4(&buf, &len, cnt * 10);
//	printf("response to UDP ping (im the server)\n");
	return Write(BUF, LEN);
	}}}
int cServer_udp::RES_ping       (unsigned char *data, size_t len) {{{ // (0x97)
//	printf("%s < 0x0097 [%15s] Server_pong   [%i]\n", currentTime_str, inet_ntoa(peer_ip), len);
	if (len != 12) return 0;
			 GET_U4((char**)&data, &len);
	uint32_t user  = GET_U4((char**)&data, &len);
	uint32_t files = GET_U4((char**)&data, &len);
	saveServer(peer_ip, peer_port - 4, files, user, false);
	if (!pongServer(peer_ip)) return 1;
	struct eServers *s = Server_ip (peer_ip);
	if (s == NULL) return 1;
	if (s->name[0] == 0 && s->desc[0] == 0) {
		UDP_next_info  	    (s->ip, s->port);
		UDP_req_server_list (s->ip, s->port);
		}
	return 1;
	}}}
int cServer_udp::RES_sources    (unsigned char *data, size_t len) {{{ // (0x9B)
	if (protocol_logLevel == 9)
		printf("%s < 0x009B src_udp  [%15s] Server_source [%i]\n", currentTime_str, inet_ntoa(peer_ip), len);
	if (len <= 17) return 0;
	tHash hash;
	GET_HASH((char**)&data, &len, hash);
	unsigned count = GET_U1((char**)&data, &len);
	log (1,"Response for (%3u) Sources for %32s from (%s:%i)\n", count, hash_bin2hex(hash),inet_ntoa(peer_ip), peer_port);
	while (count-- && len>=6) {
		struct in_addr	c_ip;
		uint16_t 	c_port;
		c_ip.s_addr = GET_U4((char**)&data, &len);
		c_port      = GET_U2((char**)&data, &len);
		if (htonl(c_ip.s_addr) < LOW_ID || c_port == 0) {
			UDP_req_callback  (c_ip.s_addr);
			}
		else {
			insertFiles (hash, c_ip, 0, NULL);
			addSource (c_ip, c_port, 0x00000000,true);
			}
		}
	return 1;
	}}}
int cServer_udp::REQ_callback   (unsigned char *DATA, size_t len) {{{ // (0x9C)
	if (len != 10) return 0;
	char *data = (char*)DATA;
	in_addr  ip;
	 ip.s_addr    = GET_U4 (&data, &len);
	uint16_t port = GET_U2 (&data, &len);
	uint32_t idx  = GET_U4 (&data, &len);
//	printf ("Handle UDP callback request\n");
	SERVER_LIST {
		if (akt->my_id != idx) continue;
		akt->CMD_callback (ip, port);
		return 1;
		}
	return 0;
	}}}
int cServer_udp::RES_search     (unsigned char *DATA, size_t LEN) {{{
	char *data = (char*)DATA;
	size_t len  = LEN;
	printf("UDP Search Results\n");
	log (1,"New extended results received from %s\n", inet_ntoa(peer_ip));
	GUI_LIST {
		class sPacket *packet = new sPacket (CO_ED_SEARCH_RESULT, len); // OK
		packet->ADD_DATA (data, len);
		packet->Send(akt);
		delete packet;
		}
	data = (char*)DATA;
	len  = LEN;
	sTag *tag = NULL;
	if (LEN > 0) {
		tHash hash;     
		GET_HASH(&data, &len, hash);
		GET_U4  (&data, &len);
		GET_U2  (&data, &len);
		tag = parse_tag       (data, &len);
		if (tag != NULL) {
			printf("Found file with %i info len %s\n", len, tag->name);
			insertFiles (hash, peer_ip, len, data);
			LEN  -= len;
			data += len;
			len   = LEN;
			delete tag;
			}
		// The Rest is List of IP:Port where the file can be found *cool* TODO ad it to the file list
		}
	return 1;
	}}}
int cServer_udp::RES_server_lst (unsigned char *DATA, size_t LEN) {{{ // (0xA1)
	char *data = (char*)DATA;
	unsigned len   = (int) LEN;
	unsigned count = GET_U1 (&data, &len);
	if (count == 0) return 0;
	log (1,"GOT %i UDP server\n", count);
	do {
		in_addr ip;
		ip.s_addr     = GET_U4 (&data, &len);
		uint16_t port = GET_U2 (&data, &len);
		if (port == 4665) port = 4661;	// very posible that this is the udp port
		if (htonl(ip.s_addr) >  0x00FFFFFF) saveServer (ip, port, 0, 0, false);	
//		else printf("low id server proto %i\n", count);
		} while (--count > 0);
	return 1;
	}}}
int cServer_udp::RES_info       (unsigned char *DATA, size_t LEN) {{{ // (0xA3)
//	printf("%s < 0x00A3 [%15s] Server_desc   [%i]\n", currentTime_str, inet_ntoa(peer_ip), LEN);
	if (!pongServer(peer_ip)) return 1;
	char *data = (char*)DATA;
	size_t len  = LEN;
	char *name = GET_S2 (&data, &len);
	char *desc = GET_S2 (&data, &len);
	log (1,"UDP Info ");
	if (name != NULL) {
		setServer_name (peer_ip, 0, name);
		log (1,"NAME: %32s ", name);
		Free2 (name);
		}
	if (desc != NULL) {
		setServer_desc (peer_ip, 0, desc);
		log (1,"DESC: %32s ", desc);
		Free2 (desc);
		}
	log (1,"\n");
	return 1;
	}}}
int cServer_udp::REQ_file_ping  (unsigned char *data, size_t len) {{{ // (0x90) TODO
	if (len != 16) return 0;
	tHash hash;
	GET_HASH((char**)&data, &len, hash);
	sFile *file = forHash(hash);
	
	char msg[4];
	char *buf = msg;
	unsigned msg_len = 4;

	log (1, "UDP %15s REQ_file_ping %32s %s\n", inet_ntoa(peer_ip), hash_bin2hex(hash),  currentTime_str);
	if (file == NULL) {
		ADD_U1 (&buf, &msg_len, OP_EDONKEYHEADER);
		ADD_U1 (&buf, &msg_len, OP_FILENOTFOUND);
		return Write (msg, 2);
		// -> OP_FILENOTFOUND,0,OP_EMULEPROT
		}
	ADD_U1 (&buf, &msg_len, OP_EDONKEYHEADER);
	ADD_U1 (&buf, &msg_len, OP_REASKACK);
	ADD_U2 (&buf, &msg_len , 50);
	return Write(msg, 4);
	// OP_QUEUEFULL,0,OP_EMULEPROT)	<-- forerst nicht nutzen
	}}}

int  cServer_udp::doRead_high(void) {{{
	unsigned char *data = (unsigned char *)read_buf;
	size_t len = read_len;
	if (len <= 0) return 0;
	dl_left -= (int)len;			// i know it maybe miss bites
	unsigned proto = GET_U1((char**)(&data), &len);
	unsigned code  = GET_U1((char**)(&data), &len);
	if (proto != OP_EDONKEYHEADER && proto!=0xC5) {
		printf ("UDP proto: 0x%02X  <= %15s:%5u\n", proto, inet_ntoa(peer_ip), peer_port);
		dump((unsigned char *)read_buf, read_len);
		Read(read_buf, read_len);
		return 0;
		}
//	printf("cServer_udp::doWork(0x%02X) = %u\n", code, len);
	switch (code) {
	case 0x90 : REQ_file_ping	(data, len); break;
	case 0x91 : RES_rang		(data, len); break;
	case 0x92 : RES_not_found	(data, len); break;
	case 0x93 : RES_queue_full	(data, len); break;
	case 0x96 : REQ_ping   		(data, len); break;
	case 0x97 : RES_ping   		(data, len); break;
//	case 0x98 : printf("UDP 0x97\n"); 	// REQ_search TODO
	case 0x99 : RES_search     	(data, len); break;
	case 0x9A : break;			// REQ_source TODO	// OP_GLOBGETSOURCE
	case 0x9B : RES_sources		(data, len); break;
	case 0x9C : REQ_callback	(data, len); break;
	case 0x9E : break;			// No such client (wrong Client ID)
	case 0xA0 : break; // TODO
	case 0xA1 : RES_server_lst	(data, len); break;
	case 0xA2 : break; // TODO
	case 0xA3 : RES_info      	(data, len); break;
	default   : printf ("UDP [%15s] <= 0x%02X : %02X\n", inet_ntoa(peer_ip), code, proto);
		    dump (data, len);
		    printf("\n");
		    if (code != 0xA0) break;
//		    ASSERT(0);
		    break;
		}
	Read(read_buf, read_len);
	return 0;
	}}}

